###########################################
###              jWarn v0.1             ###
###########################################
##      Requires: EventScripts v2.*     ###
##  By James Haigh [nitrouskillers.com]  ##
###########################################

## Thanks to:
# - Venjax for creating the original vWarn
# - SuperDave for helping me fix (many) parts of the code ;)
# - sn4k3 for helping me with some es.msg problems


# Don't remove!
import es
from es import server_var

##########################################################################################################################################
# Change these variables to your liking.
admins = "STEAM_0:1:7519567-" # STEAM ID's of your admins, seperated by a dash (-). Put a dash (-) on the end for security purposes.
allow_warn_admins = 1 # Allow admins to warn other admins?
notify_admins = 1 # Notify all admins (instead of just the person who issued the warning) when someone gets warned?
slay_warned = 1 # Slay a player when they receive a warning?
anonymous = 1 # Anonymous Warnings (the admins name isn't shown to the warned player)
warns_kick = 3 # Amount of warns to kick a player
warns_ban = 6 # Amount of warns to ban a player
warns_ban_time = 2880 # Time to ban a player (in minutes). [default = 2880 = 48 hours]
##########################################################################################################################################


### Don't modify anything else unless you know what you're doing!

# Please do not modify or remove :)
info = es.AddonInfo()
info['name']        = "jWarn"
info['version']     = "0.1"
info['author']      = "James Haigh"
info['url']         = "jhaigh@gmail.com"
info['description'] = "Warns (and optionally kicks/slays/bans) players who break the rules."

def _wrap_es_getargc(varname):
   x = es.getargc()
   es.set(varname, str(x))

def _wrap_es_getargv(varname, argument):
   x = es.getargv(argument)
   es.set(varname, str(x))

def _wrap_es_getargs(varname):
   x = es.getargs()
   es.set(varname, x)

def _wrap_es_getcmduserid(varname):
   x = es.getcmduserid()
   es.set(varname, str(x))

def load():
   # Set up some variables.
   es.set("vtoke2", "0")
   es.set("vtoke3", "0")
   es.set("admin_userid", "0")
   es.set("admin_steamid", "0")
   es.set("admin_name", "0")
   es.set("tokefix", "0")
   # Variables which are unique to this script.
   es.set("jwarn_active", "1")
   es.set("jwarn_ver", "0.1")
   es.makepublic("jwarn_active")
   es.makepublic("jwarn_ver")
   # Load up the database.
   es.keygroupload("jwarn", "|jwarn")
   # Register the command which allows admins to warn players in chat.
   es.regsaycmd("warn","jwarn/warnem","Warns players")

def unload():
   # Unload the database.
   es.keygroupdelete("jwarn", "|jwarn")

def warnem():
   # Grab the admins variable.
   global admins
   # Find out who is trying to issue a warning.
   _wrap_es_getcmduserid('admin_userid')
   es.set('admin_name',es.getplayername(es.ServerVar('admin_userid')))
   es.set('admin_steamid',es.getplayersteamid(es.ServerVar('admin_userid')))
   # Is the player an admin?
   if (es.ServerVar('admin_steamid') in str(admins).split('-')):
      # If so, issue the warning.
      es.doblock('jwarn/warn_player')
   else:
      es.tell(es.ServerVar('admin_userid'),"\x04You are not an admin.")

def warn_player():
   # Get the variables we'll need.
   global admins
   global allow_warn_admins
   global notify_admins
   global slay_warned
   global anonymous
   global warns_kick
   global warns_ban
   global warns_ban_time
   # Get the playername and the reason and store them in variables.
   _wrap_es_getargv('vtoke2', 1)
   _wrap_es_getargs('vtoke3')
   # This was here from vWarn. Don't ask me why, how, or what it does.
   es.format("tokefix", "%1 ",es.ServerVar('vtoke2'))
   es.server.cmd("es_string vtoke3 replace server_var(tokefix)")
   es.server.cmd("es_string vtoke3 replace server_var(vtoke2)")
   # Store the reason and userid of the player in Python vars
   warned_reason = es.ServerVar('vtoke3')
   warned_id = es.getuserid(es.ServerVar('vtoke2'))
   # Is the player on the server?
   if warned_id == 0:
      # If not, show an error to the admin.
      es.menu("5",es.ServerVar('admin_userid'),"->1. Error!\nNo such user!")
   else:
      # We have the player, let's get his/her Steam ID.
      warned_steamid = es.getplayersteamid(warned_id)
      # Are we trying to warn an admin?
      if(warned_steamid in str(admins).split('-')) and allow_warn_admins == 0:
         # Oops...
         es.menu("5",es.ServerVar('admin_userid'),"->1. Error\nYou can't warn another admin!")
      else:
         # Get the player's name for later.
         warned_name = es.getplayername(warned_id)
         # If the user hasn't yet received any warnings...
         if not es.exists("key","jwarn",warned_steamid):
            # Give them their own key in the database.
            es.keycreate("jwarn",warned_steamid)
            es.keysetvalue("jwarn",warned_steamid,"warns","0")
         # Add 1 to the amount of warnings the player has (retreived from the DB).
         warns = int(es.keygetvalue("jwarn",warned_steamid,"warns")) + 1
         # Update the DB.
         es.keysetvalue("jwarn",warned_steamid,"warns",warns)
         # You guessed it. Save the DB.
         es.keygroupsave("jwarn", "|jwarn")
         if notify_admins == 1:
            global admins
            # If we're notifying all admins, send them all a message.
            for tempadminsteam in str(admins).split('-'):
               # Just checking if we're actually sending this to a player...
               if not tempadminsteam == '-':
                  tempadminid = es.getuserid(tempadminsteam)
                  es.menu("5",tempadminid,'->1. Player Warned\n' + es.ServerVar('admin_name') + ' just issued a warning to ' + warned_name + '.\n \n->2. Reason\n' + warned_reason + '\n \n->3. Warns\nThe player has a total of ' + str(warns) + ' warning(s).')
         else:
            # If we're not telling all the admins, just tell the admin who issued the warning.
            es.menu("5",es.ServerVar('admin_userid'),'->1. Player Warned\n' + warned_name + ' has been issued a warning.\n \n->2. Reason\n' + warned_reason + '\n \n->3. Warns\nThey player has a total of ' + str(warns) + ' warning(s).')
         if slay_warned == 1:
            # Slay the bad player.
            es.sexec(warned_id,"kill")
         if warned_reason == '':
            # If the admin is lazy and forgot to give a reason, they are not only a bad admin, but we need to replace the empty var.
            warning_reason = 'No reason given.'
         else:
            warning_reason = warned_reason
         # Show the user their warning
         # ..if we want the warning to be anonymous
         if anonymous == 1:
            es.menu("0",warned_id,'->1. Warning\nYou have been issued a warning.\n \n->2. Reason\n' + warning_reason + '\n \n->3. Close')
         else:
            es.menu("0",warned_id,'->1. Warning\nYou have been issued a warning by ' + es.ServerVar('admin_name') + '.\n \n->2. Reason\n' + warning_reason + '\n \n->3. Close')
            
         # If the user is about to have their last warning before they get banned.
         if warns >= warns_ban:
               # Ban the user
               es.server.cmd('banid ' + str(warns_ban_time) + ' ' + warned_steamid)
               # Kick
               es.server.cmd('kickid ' + warned_steamid + ' ' + warning_reason)
               # Notify everyone
               es.msg('\x04' + warned_name + ' has been given enough warnings and therefore banned from the server.')
         # Else, if the user is about to be kicked
         elif warns >= warns_kick:
               # Kick the user
               es.server.cmd('kickid ' + warned_steamid + ' ' + warning_reason)
               # Notify everyone
               es.msg('\x04' + warned_name + ' has been given enough warnings and therefore kicked from the server.')
